// FileGet.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "FTUtil.h"

#define WSIMFILEGET_APP_MUTEX	_T("WSIM FileGet App Mutex")

static
BOOL
GetAppPath(
	LPTSTR	pPath
)
{
	BOOL	bRet;
	TCHAR	szPath[MAX_PATH + 1];
	LPTSTR	p = NULL;

	bRet = FALSE;

	if (pPath == NULL) {
		return FALSE;
	}

	memset(szPath, 0, sizeof(szPath));
	GetModuleFileName(NULL, szPath, sizeof(szPath)/sizeof(szPath[0]));
	p = _tcsrchr(szPath, _T('\\'));
	if (p != NULL) {
		*(p+1) = _T('\0');

		_tcscpy(pPath, szPath);

		bRet = TRUE;
	}

	return bRet;
}


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	int		iRet;
	HANDLE	hMutex = NULL;
	BOOL	bShowList = FALSE;

	// dN`FbN
	hMutex = CreateMutex(NULL, TRUE, WSIMFILEGET_APP_MUTEX);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {

			MessageBox(NULL, _T("ɋNł"), _T("WSIMFileGet"), MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND); 

			CloseHandle(hMutex);
			hMutex = NULL;
			return FALSE;
		}
	}
	else {
		return FALSE;
	}
	//

	if (lpCmdLine == NULL || _tcslen(lpCmdLine) == 0) {
		bShowList = TRUE;
	}

	if (FTUtil_Initialize()) {

		// WSIMւ̃ANZX̊Jn
		iRet = FTUtil_ProcessBegin();
		Sleep(100);

		if (iRet == 1) {
			struct WSIMFileList_TAG	fileList;
			int	idx;

			memset(&fileList, 0, sizeof(fileList));

			// WSIMɕۑĂt@C̃Xg擾
			iRet = FTUtil_GetFileList(&fileList);
			Sleep(100);

			if (iRet == 0) {
				if (bShowList) {
					WCHAR	szMsgBuf[1024];
					WCHAR	szFileName[WSIM_MAX_FILENAME];

					memset(szMsgBuf, 0, sizeof(szMsgBuf));
					for (int i = 0; i < WSIM_MAX_FILE_NUM; i++) {

						// ANSI->UNICODE
						wsprintf(szFileName, _T("%S"), fileList.szFileNames[i]);

						if (wcslen(szFileName) != 0) {
							wcscat(szMsgBuf, szFileName);
							wcscat(szMsgBuf, L"\n");
						}
					}
					MessageBox(NULL, szMsgBuf, _T("WSIMFileGet"), MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);

				}
				else {
					WCHAR	szFileName[WSIM_MAX_FILENAME];

					idx = WSIM_MAX_FILE_NUM;
					for (int i = 0; i < WSIM_MAX_FILE_NUM; i++) {
						// t@CXgwt@C

						// ANSI->UNICODE
						wsprintf(szFileName, _T("%S"), fileList.szFileNames[i]);

						if (wcsicmp(szFileName, lpCmdLine) == 0) {
							idx = i;
							break;
						}
					}

					if (idx < WSIM_MAX_FILE_NUM) {
						// t@CXgɎwt@C̂ŁC
						// WSIMt@C擾

						TCHAR	szAppPath[MAX_PATH + 1];
						TCHAR	szOutputPath[MAX_PATH + 1];

						// ۑt@CpX̍쐬
						if (GetAppPath(szAppPath)) {
							wsprintf(szOutputPath, _T("%s\\%s"), szAppPath, lpCmdLine);

							// W-SIMt@C̎擾
							iRet = FTUtil_RecvFile(szOutputPath, szFileName, fileList.ulFileSizes[idx]);

							MessageBox(NULL, _T("擾"), _T("WSIMFileGet"), MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
						}

					}
					else {
						TCHAR	szBuf[128];

						wsprintf(szBuf, _T("%sWSIMɌ܂łB"), lpCmdLine);
						MessageBox(NULL, szBuf, _T("WSIMFileGet"), MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
					}
				}
			}
			else {
				MessageBox(NULL, _T("WSIM̃t@CXg擾Ɏs܂B"), _T("WSIMFileGet"), MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
			}

			// WSIMւ̃ANZX̏I
			FTUtil_ProcessEnd();
		}
		else {
			MessageBox(NULL, _T("WSIMւ̃ANZXɎs܂"), _T("WSIMFileGet"), MB_OK|MB_ICONINFORMATION|MB_SETFOREGROUND);
		}

		FTUtil_Terminate();
	}
	else {
		MessageBox(NULL, _T("CȕɎs܂B"), _T("WSIMFileGet"), MB_OK);
	}


	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	return 0;
}

